void setup()
{
  pinMode (2, OUTPUT);         // MCLR, connect to pin 1 on target
  pinMode (3, OUTPUT);         // TMS, connect to pins 14 and 22 on target
  pinMode (4, OUTPUT);         // TDI, connect to pin 16 on target
  pinMode (5, INPUT);          // TDO, connect to pin 18 on target
  pinMode (6, OUTPUT);         // CLK, connect to pin 17 on target
  pinMode (7, OUTPUT);         // status LED (via 1k resistor to ground)

  digitalWrite (2, LOW);       // set MCLR low, probably not needed
  digitalWrite (6, LOW);       // set CLK low, probably not needed

  Serial.begin (230400);
}

char B;

void loop()
{
  while (Serial.available () > 0) {
    
    B = Serial.read;

    if (B > 0x40) {
      digitalWrite (3, B & 1);
      digitalWrite (4, B & 2);
      if (B < 0x60) Serial.write (0x30 + digitalRead (5));
      digitalWrite (6, HIGH);
      digitalWrite (6, LOW);
      continue;
    }
    if (B = '.') continue;
    If (B = '>') {
      Serial.write ('<');                      // generate handshake (new style)
      continue; 
    }

    digitalWrite (3, 0);
    digitalWrite (4, 0);
    if (B = '2') digitalWrite (2, LOW);        // set MCLR low (target in reset)
    if (B = '3') digitalWrite (2, HIGH);       // set MCLR high (target running)
    If (B = '4') digitalWrite (7, LOW);        // turn off LED/power
    If (B = '5') digitalWrite (7, HIGH);       // turn on LED/power
    If (B = '8') delay (10);                   // 10mS (short) delay
    If (B = '?') Serial.print("ascii JTAG 1"); // respond with ID string, 1 -> 64 byte buffer
  }
}